from zope.interface import implements
from Products.Five.browser import BrowserView
from Products.CMFCore.utils import getToolByName
from Products.Collage.interfaces import ICollageAlias, ICollage
from collective.easyslider.interfaces import ISliderPage, ISliderUtil
from collective.easyslider.browser.utils import SliderUtil

class CollageSliderUtil(SliderUtil):
    """
    a public traverable utility that checks if a
    slide is enabled
    """
    implements(ISliderUtil)

    def should_include(self):
        utils = getToolByName(self.context, 'plone_utils')
        for row in self.context.folderlistingFolderContents():
            for column in row.folderlistingFolderContents():
                for item in column.folderlistingFolderContents():
                    if item.layout == "sliderview":
                        return True
                    if ICollageAlias.providedBy(item):
                        item=item.get_target()
                    if ISliderPage.providedBy(item) or \
                       utils.browserDefault(item)[1][0] == "sliderview":
                        return True
        return False
