# -*- coding: utf-8 -*-
'''
Created on 11/12/2009

@author: jpg
'''
from Products.Collage.browser.views import BaseView
from collective.easyslider.browser.views import SliderView
from collective.easyslider.interfaces import ISliderPage
from Products.Collage.interfaces import ICollageColumn, ICollageAlias
from AccessControl.SecurityManagement import getSecurityManager
from AccessControl.unauthorized import Unauthorized
from Products.CMFCore.utils import getToolByName
from Products.ATContentTypes.interface.folder import IATFolder
from Products.ATContentTypes.interface.topic import IATTopic

class EasySliderView(SliderView, BaseView):
    """ Collage view implementing jQuery Easy Slider
    """

    def has_slider_already(self):
        """ Check for a slider being present on the folder/container
            already. If there is one, then we should let it persist.
        """
        return ISliderPage.providedBy(self.context)

    def get_items(self):
        res = []
        if ICollageColumn.providedBy(self.context):
            catalog = getToolByName(self.context, 'portal_catalog')
            contents = self.context.folderlistingFolderContents()
            for context in contents:
                if context is None:
                    continue
                target = context
    
                if ICollageAlias.providedBy(context):
                    target = context.get_target()
                    # if not set, revert to context
                    if target is None:
                        target = context
    
                    # verify that target is accessible
                    try:
                        getSecurityManager().validate(self, self, target.getId(), target)
                    except Unauthorized:
                        continue
                    
                if not target.portal_type in self.settings.allowed_types:
                    continue
                
                class mybrains:
                    alias = context                
                catalog._catalog.useBrains(mybrains)
                items = catalog(UID=target.UID())
                res.extend(items)
                
            if self.settings.limit > 0:
                res = res[:self.settings.limit]            
        elif IATFolder.providedBy(self.context) or IATTopic.providedBy(self.context):
            res = super(EasySliderView, self).get_items()

        return res
