import sys
import unittest
from IPython.Shell import IPShellEmbed

from Testing import ZopeTestCase as ztc

from Products.Five import zcml
from Products.Five import fiveconfigure
from Products.PloneTestCase import PloneTestCase as ptc
from Products.PloneTestCase.layer import onsetup

from Products.PloneTestCase.layer import PloneSite

from Products.CMFPlone.tests import dummy

@onsetup
def setup_product():
    """Set up the package and its dependencies.

    The @onsetup decorator causes the execution of this body to be
    deferred until the setup of the Plone site testing layer. We could
    have created our own layer, but this is the easiest way for Plone
    integration tests.
    """

    # Load the ZCML configuration for the example.tests package.
    # This can of course use <include /> to include other packages.

    fiveconfigure.debug_mode = True
    import collective.collage.easyslider
    zcml.load_config('configure.zcml', collective.collage.easyslider)
    fiveconfigure.debug_mode = False

    ztc.installPackage('collective.collage.easyslider')

ztc.installProduct('Collage')
setup_product()
ptc.setupPloneSite(products=['collective.collage.easyslider',])

class TestCase(ptc.PloneTestCase):
    """We use this base class for all the tests in this package. If
    necessary, we can put common utility or setup code in here. This
    applies to unit test cases.
    """

class FunctionalTestCase(ptc.FunctionalTestCase):
    """We use this class for functional integration tests that use
    doctest syntax. Again, we can put basic common utility or setup
    code in here.
    """

    def afterSetUp(self):
        ptc.FunctionalTestCase.afterSetUp(self)

        self.folder.invokeFactory('Folder', id='slider_folder', title='SliderFolder')
        self.folder.slider_folder.invokeFactory('Image', id='slider_image', title='FirstImage', file=dummy.File())
        self.folder.slider_folder.invokeFactory('Image', id='slider_image2', title='SecondImage', file=dummy.File())

	_ = self.folder.invokeFactory(id='example-collage', type_name='Collage')
 	collage = self.folder[_]
        _= collage.invokeFactory(id='row', type_name='CollageRow')
        row = collage[_]
        row.invokeFactory(id='column', type_name='CollageColumn')

    def ipython(self, locals=None):
        """Provides an interactive shell aka console inside your testcase.
        Uses ipython for on steroids shell...

        It looks exact like in a doctestcase and you can copy and paste
        code from the shell into your doctest. The locals in the testcase are
        available, becasue you are in the testcase.

        In your testcase or doctest you can invoke the shell at any point by
        calling::

            >>> self.ipython( locals() )

        locals -- passed to InteractiveInterpreter.__init__()
        """
        savestdout = sys.stdout
        sys.stdout = sys.stderr
        sys.stderr.write('='*70)
        embedshell = IPShellEmbed(argv=[],
                                  banner="""
IPython Interactive Console

Note: You have the same locals available as in your test-case.
""",
                                  exit_msg="""end of ZopeTestCase Interactive Console session""",
                                  user_ns=locals)
        embedshell()
        sys.stdout.write('='*70+'\n')
        sys.stdout = savestdout

